/* vi: set sw=4 ts=4: */
/*
 * CCE - Console Chinese Environment -
 * Copyright (C) 1998-2003 Rui He (rhe@3eti.com)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>

#include "defs.h"

#if defined(__MSDOS__)

#include <sys/nearptr.h> /* for gramMem access */

#include <libc/file.h>  /* for IOWRT etc */

#ifndef HAVE_SNPRINTF 

int snprintf(char *str, size_t n, char const *fmt, ...)
{
	int ret;
	va_list ap;
	FILE f;

	if ((int)n < 1)
		return (EOF);
	va_start(ap, fmt);
	f._flag = _IOWRT |_IOSTRG|_IONTERM;
	f._base = f._ptr = (char *)str;
	f._bufsiz = f._cnt = n - 1;
	ret = vfprintf(&f, fmt, ap);
	*f._ptr = 0;
	va_end(ap);

	return (ret);
}

#endif

int DJGPPMmapVideoRAM(unsigned char **gMem)
{
	if (__djgpp_nearptr_enable() == 0) return FAILURE;

	*gMem = (unsigned char *)(0xA0000 + __djgpp_conventional_base);

	return SUCCESS;
}

int DJGPPMunmapVideoRAM(void)
{
	__djgpp_nearptr_disable();
}

#endif
